' PipeOut.VBS V1.01 (C) yoshioka.teruo@nifty.com 2006-07-22
' PipeOut.VBS shows file content concurrently when another process is writing.
' Usage: WScript.exe PipeOut.VBS file
' Usage: CScript.exe //NoLogo PipeOut.VBS file >stdout

Option Explicit
Const ForReading=1
Dim fso
Dim StdIn
Dim ie
Dim Line

If WScript.Arguments.Count<>1 Then
  WScript.Echo "Argument Missing."
  WScript.Quit
End If

Set fso=CreateObject("Scripting.FileSystemObject") 
Set StdIn=fso.OpenTextFile(WScript.Arguments.Item(0),ForReading,False) 
If LCase(fso.GetBaseName(WScript.FullName))="wscript" Then
  Set ie=CreateObject("InternetExplorer.Application")
  ie.Menubar=False 
  ie.Toolbar=False 
  ie.Statusbar=False 
  ie.Navigate "about:blank"
  Do While ie.Busy Or ie.ReadyState<>4
    WScript.Sleep 100
  Loop
  ie.Document.title=WScript.ScriptName
  ie.Visible=True
End If

Do
  If StdIn.AtEndOfStream Then
    If IsEndOfPipe(WScript.Arguments.Item(0)) Then If StdIn.AtEndOfStream Then Exit Do
    WScript.Sleep 1000
  Else
    Line=StdIn.ReadLine()
    Write Line
  End If
Loop
StdIn.Close
Write "<EOF>"
WScript.Quit

Sub Write(Line)
If IsEmpty(ie) Then
  WScript.StdOut.WriteLine Line
Else
  ie.Document.body.insertAdjacentText "BeforeEnd",Line & vbCrLf
  ie.Document.body.doScroll "pagedown"
End If
End Sub

Function IsEndOfPipe(Path)
Const ForAppending=8
On Error Resume Next
Call fso.OpenTextFile(Path,ForAppending,False)
IsEndOfPipe=CBool(Err.Number<>70)
End Function

